package com.suning.epa_plugin.utils

import android.app.Activity
import com.suning.epa_plugin.EPAFusionInfoUtil
import com.suning.epa_plugin.config.ConfigNetwork
import com.suning.epa_plugin.config.StrsContents
import com.suning.epa_plugin.precashier.EfpProxy
import com.suning.epa_plugin.trust_login.LoginController
import com.suning.epa_plugin.utils.custom_view.EbuyDependMethond
import com.suning.epa_plugin.utils.custom_view.ProgressViewDialog
import com.suning.epa_plugin.webview.EfwProxy

/**
 * @Author 17033098
 * @Date 2019/10/22 14:10
 * @Description
 */
object EpaFusionPreCashierUtil {
    fun start(activity: Activity, isPayment : Boolean, jsonStr : String){
        EfpProxy.start(activity, StrsContents.PLUGIN_VERSION, isPayment, jsonStr, object : EfpProxy.EfpListener{
            override fun doLogin(callBack: (Boolean) -> Unit) {
                LoginController.getInstance().addOnLoginListener { isSuccess ->
                    callBack(isSuccess)
                }
                doTrustLogin(activity)
            }

            override fun toH5(activity: Activity, url: String) {
                EfwProxy.start(activity, url)
            }

            override fun toBill(activity: Activity, orderId: String) {
                var url = ConfigNetwork.getConfigNetwork().myBillsDetailsUrl
                url = "$url&orderNo=$orderId&goodtype=011001#info"
                EfwProxy.start(activity, url)
            }

        })
    }

    private fun doTrustLogin(context: Activity) {
        LoginController.isEPALogin = false

        // 易购登录下去信任登录易付宝
        if (EbuyDependMethond.isEbuyLogon()) {
            // 没有正在信任登陆的操作，并且状态为未登陆，做登陆
            if (!LoginController.isEPALoginning && !LoginController.isEPALogin) {
                // 开始这个过程
                LoginController.isEPALoginning = true
                ProgressViewDialog.getInstance().showProgressDialog(context)
                LoginController.getInstance().toTrustLogin(context)
            }
        } else {
            EPAFusionInfoUtil.getEpaListener().callExternalLogin { isLogin ->
                if (isLogin) {
                    doTrustLogin(context)
                }
            }
        }
    }
}